import wizard
import pooler
from tools.misc import UpdateableStr, UpdateableDict

view2="""<?xml version="1.0"?>
<form string="Create requirement for selected lines">
    <field name="lines" colspan='4' nolabel='1'/>
</form>
"""

view1="""<?xml version="1.0"?>
<form string="Create requirement for all lines">
    <field name="req_day"/>
</form>
"""

_field1={
    "req_day": { "type": "integer", "string": "Lead Time(Day)", "required": False },
}

_fields = UpdateableDict()

class wizard_make_prq(wizard.interface):
    def _get_defaults(self, cr, uid, data, context):
        #print "sale mark prq get default" , data
        pool = pooler.get_pool(cr.dbname)
        #sale_obj = pool.get('sale.order').browse(cr,uid,data["ids"])
        lines =[] 
        _fields.clear()
        for sol in pool.get('sale.order').browse(cr,uid,data["ids"]):
            for line in sol.order_line:
                if not line.prq_line_id:
                    lines.append(line.id)
        #print "lines" ,  lines
        data['form']['lines'] = lines # set default to form
        #_fields['req_day'] = {'string': 'Required Date','type' : 'integer' }
        _fields['lines'] = {'string': 'SO Lines','type' : 'many2many', 'relation':'sale.order.line', 'domain':"[('id','in',%s)]"%lines}
        #print _fields
        return data['form']

    def _make(self,cr,uid,data,context):
        print "wiz _make_purchase.requirement"
        ids=data['form']["lines"]
        pool=pooler.get_pool(cr.dbname)
        line_ids =[]
        for so in ids:
            line_ids = line_ids+ so[2]
        req_day = data['form']['req_day']
        if line_ids:
            prq_ids = pool.get("sale.order.line").make_prq(cr,uid,line_ids,req_day)
        return {}

    def _make_all(self,cr,uid,data,context):
        print "wiz _make_all"
        ids=data["ids"]
        pool=pooler.get_pool(cr.dbname)
        so_obj = pool.get("sale.order").browse(cr,uid,ids)
        line_ids =[]
        for so in so_obj:
            for line in so.order_line:

                if not line.prq_line_id:
                    line_ids.append(line.id)
        req_day = data['form']['req_day']
        if line_ids:
            prq_ids = pool.get("sale.order.line").make_prq(cr,uid,line_ids,req_day)
        return {}

    states={
        "init": {
            "actions": [],
            "result": {
                "type": "form",
                "arch": view1,
                "fields": _field1,
                "state": [("make_all","All",'gtk-apply'),("select","Select",'gtk-go-forward',True),("end","Cancel")],
            },
        },
        "make_all": {
            "result": {
                "type": "action",
                "action": _make_all,
                "state": "end",
            }
        },
        "select": {
            "actions": [_get_defaults],
            "result": {
                "type": "form",
                "arch": view2,
                "fields":_fields,
                "state": [("init","Back"),("make_select","Make",'',True),("end","Cancel")],
            }
        },

        "make_select": {
            "result": {
                "type": "action",
                "action": _make,
                "state": "end",
            }
        },
    }

wizard_make_prq("make.prq")
